//----------------------------------------------------------------------//
// NyanFi																//
//  fBNg/ X^bN											//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <RegularExpressions.hpp>
#include "UserFunc.h"
#include "Global.h"
#include "MainFrm.h"
#include "HistDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDirHistoryDlg *DirHistoryDlg;

//---------------------------------------------------------------------------
__fastcall TDirHistoryDlg::TDirHistoryDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormCreate(TObject *Sender)
{
	ListBuff = new TStringList();

	ListScrPanel = new UsrScrollPanel(ListPanel, DirHistListBox, USCRPNL_FLAG_P_WP | USCRPNL_FLAG_L_WP);

	IsDirStack = IsAllDirHist = IsFindDirHist = false;
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);
	IsMigemo = IniFile->ReadBoolGen(_T("DirHistoryMigemo"));

	RefListTag	 = CurListTag;
	WorkListName = EmptyStr;

	HdrPanel->ClientHeight = get_FontHeight(ListFont, 4, 4);
	HdrPanel->Font->Assign(ListFont);
	HdrPanel->Color 	  = col_bgList;
	HdrPanel->Font->Color = col_fgList;
	HdrPanel->Caption = IncSeaWord = EmptyStr;
	HdrPanel->Visible = IsFindDirHist;

	set_StdListBox(DirHistListBox);
	set_UsrScrPanel(ListScrPanel);

	int *h_ptr = (IsDirStack || IsAllDirHist)? NULL : get_DirHistPtr(CurTabIndex, CurListTag);
	UpdateListBox(h_ptr? *h_ptr : 0);
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IsDirStack = IsAllDirHist = IsFindDirHist = false;

	IniFile->SavePosInfo(this);
	IniFile->WriteBoolGen(_T("DirHistoryMigemo"), IsMigemo);
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormDestroy(TObject *Sender)
{
	delete ListBuff;
	delete ListScrPanel;
}

//---------------------------------------------------------------------------
//ꗗ̍XV
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::UpdateListBox(
	int idx)	//CfbNX	(default = 0)
{
	ListBuff->Clear();

	//tB^[h
	if (IsFindDirHist) {
		HdrPanel->Caption = (IsMigemo? " Migemo: " : "") + IncSeaWord;
		HdrPanel->Repaint();

		TStringDynArray wd_lst = SplitString(Trim(IncSeaWord), " ");
		std::unique_ptr<TStringList> ptn_lst(new TStringList());
		for (int i=0; i<wd_lst.Length; i++) {
			UnicodeString ptn = IsMigemo? usr_Migemo->GetRegExPtn(true, wd_lst[i]) : wd_lst[i];
			if (!ptn.IsEmpty()) ptn_lst->Add(ptn);
		}

		if (ptn_lst->Count>0) {
			std::unique_ptr<TStringList> f_lst(new TStringList());
			TRegExOptions opt; opt << roIgnoreCase;
			for (int i=0; i<AllDirHistory->Count; i++) {
				UnicodeString lbuf = AllDirHistory->Strings[i];
				UnicodeString fnam = get_csv_item(lbuf, 0);
				bool ok = true;
				if (IsMigemo) {
					for (int j=0; j<ptn_lst->Count && ok; j++)
						ok = TRegEx::IsMatch(fnam, ptn_lst->Strings[j], opt);
				}
				else {
					for (int j=0; j<ptn_lst->Count && ok; j++)
						ok = ContainsText(fnam, ptn_lst->Strings[j]);
				}
				if (ok) f_lst->Add(lbuf);
			}
			ListBuff->Assign(f_lst.get());
		}
		else
			ListBuff->Assign(AllDirHistory);
	}
	//ʏ탂[h
	else {
		TStringList *h_lst = IsDirStack? DirStack : IsAllDirHist? AllDirHistory : get_DirHistory(CurTabIndex, RefListTag);
		if (h_lst) ListBuff->Assign(h_lst);
	}

	//Xg{bNXɊ蓖(z)
	TListBox *lp = DirHistListBox;
	int top = lp->TopIndex;
	lp->Count = ListBuff->Count;
	lp->TopIndex = top;
	if (lp->Count>0) lp->ItemIndex = (idx<lp->Count)? idx : lp->Count - 1;
	lp->SetFocus();
	ListScrPanel->UpdateKnob();

	//^Cg
	UnicodeString tit;
	if (IsDirStack)
		tit.USET_T("fBNgEX^bN");
	else if (IsFindDirHist)
		tit.sprintf(_T("fBNg - Š (%u/%u)"), ListBuff->Count, AllDirHistory->Count);
	else if (IsAllDirHist)
		tit.USET_T("fBNg - S");
	else {
		tit.sprintf(_T("fBNg - %s"), get_LRUD_str(RefListTag).c_str());
		if (RefListTag!=CurListTag) tit.UCAT_T(" (ΑQ)");
	}
	Caption = tit;
}

//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxData(TWinControl *Control, int Index, UnicodeString &Data)
{
	Data = (Index>=0 && Index<ListBuff->Count)? ListBuff->Strings[Index] : EmptyStr;
}

//---------------------------------------------------------------------------
//ڂ̕`
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxDrawItem(TWinControl *Control, int Index,
	TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas *cv = lp->Canvas;
	cv->Font->Assign(ListFont);
	cv->Brush->Color = col_bgList;
	cv->FillRect(Rect);

	int xp = Rect.Left + 2;
	int yp = Rect.Top + get_TopMargin2(cv);

	if (!IsFindDirHist) {
		if (Index<10) {
			cv->Font->Color = col_fgList;
			cv->Font->Style = cv->Font->Style << fsUnderline;
			cv->TextOut(xp, yp, UnicodeString().sprintf(_T("%u"), (Index + 1)%10));
		}
		cv->Font->Style = cv->Font->Style >> fsUnderline;
		xp += get_CharWidth(cv, 2);
	}

	UnicodeString lbuf = get_csv_item(lp->Items->Strings[Index], 0);
	if (UncToNetDrive) lbuf = UNC_to_NetDriveName(lbuf);
	if (DispRegName)   lbuf = get_RegDirName(lbuf);
	lbuf = yen_to_slash(lbuf);

	cv->Font->Color = col_Folder;
	cv->TextOut(xp, yp, lbuf);

	//J[\
	draw_ListCursor2(lp, Rect, Index, State);
}

//---------------------------------------------------------------------------
//L[
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxKeyDown(TObject *Sender, WORD &Key,
		TShiftState Shift)
{
	UnicodeString KeyStr = get_KeyStr(Key, Shift);	if (KeyStr.IsEmpty()) return;

	UnicodeString cmd_F  = Key_to_CmdF(KeyStr);
	UnicodeString cmd_S  = IsFindDirHist? KeyFuncList->Values["S:" + KeyStr] : EmptyStr;
	bool handled = true;

	try {
		bool is_all = (IsAllDirHist || IsFindDirHist);
		TStringList *h_lst = is_all? AllDirHistory :
						 IsDirStack? DirStack : get_DirHistory(CurTabIndex, RefListTag);
		int *h_ptr = (IsDirStack || IsAllDirHist || IsFindDirHist)? NULL : get_DirHistPtr(CurTabIndex, CurListTag);

		TListBox *lp = (TListBox*)Sender;
		UnicodeString lst_itm = (lp->ItemIndex!=-1)? lp->Items->Strings[lp->ItemIndex] : EmptyStr;

		//m
		if ((!IsFindDirHist && is_Num0to9(KeyStr)) || equal_ENTER(KeyStr)) {
			int idx = is_Num0to9(KeyStr)? ((KeyStr.ToIntDef(0) + 9)%10) : lp->ItemIndex;
			if (idx<0 || idx>=lp->Count) Abort();
			UnicodeString dnam = get_csv_item(lp->Items->Strings[idx], 0);
			//fBNg
			if (ends_PathDlmtr(dnam)) {
				if (dir_exists(dnam)) {
					bool is_cur = (RefListTag==CurListTag);
					if (!is_all && is_cur && h_ptr) *h_ptr = idx;
					NyanFiForm->UpdateCurPath(dnam, -1, is_cur);
					ModalResult = mrOk;
				}
				else {
					msgbox_WARN(USTR_NotFound);
					//݂ȂfBNg폜
					if (h_lst) {
						int i = 0;
						while (i<h_lst->Count) {
							if (SameText(dnam, get_csv_item(h_lst->Strings[i], 0))) h_lst->Delete(i); else i++;
						}
						UpdateListBox(idx);
					}
				}
			}
			//[NXg
			else if (test_NwlExt(get_extension(dnam))) {
				WorkListName = dnam;
				ModalResult  = mrOk;
			}
		}
		//tB^
		else if (IsFindDirHist && update_IncSeaWord(IncSeaWord, KeyStr)) {
			UpdateListBox();
		}
		else if (USAME_TI(cmd_S, "ClearIncKeyword")) {
			IncSeaWord = EmptyStr;
			UpdateListBox();
		}
		else if (USAME_TI(cmd_S, "MigemoMode")) {
			IsMigemo = (!IsMigemo && usr_Migemo->DictReady);
			UpdateListBox();
		}
		//J[\ړ
		else if (USAME_TI(cmd_S, "IncSearchUp"))	ListBoxCursorUp(lp);
		else if (USAME_TI(cmd_S, "IncSearchDown"))	ListBoxCursorDown(lp);
		else if (MovListBoxFromFilter(lp, KeyStr))	;
		else if	(ExeCmdListBox(lp, cmd_F))			;
		//ڂ̍폜
		else if (equal_DEL(KeyStr) || USAME_TI(cmd_F, "Delete")) {
			if (lp->ItemIndex==-1) Abort();
			if (IsFindDirHist) {
				UnicodeString dnam = get_csv_item(lp->Items->Strings[lp->ItemIndex], 0);
				for (;;) {
					int idx = indexof_csv_list(AllDirHistory, dnam, 0);
					if (idx!=-1) AllDirHistory->Delete(idx); else break;
				}
			}
			else {
				if (h_lst) h_lst->Delete(lp->ItemIndex);
			}
			UpdateListBox(lp->ItemIndex);
		}
		//Α̗Q
		else if (!IsFindDirHist && (equal_RIGHT(KeyStr) || contained_wd_i(_T("ToRight|ToParentOnRight"), cmd_F))) {
			if (h_ptr && RefListTag==0) {
				RefListTag = 1;
				int *h_p = get_DirHistPtr(CurTabIndex, RefListTag);
				if (h_p) UpdateListBox(*h_p);
			}
		}
		else if (!IsFindDirHist && (equal_LEFT(KeyStr) || contained_wd_i(_T("ToLeft|ToParentOnLeft"), cmd_F))) {
			if (h_ptr && RefListTag==1) {
				RefListTag = 0;
				int *h_p = get_DirHistPtr(CurTabIndex, RefListTag);
				if (h_p) UpdateListBox(*h_p);
			}
		}
		//
		else if (USAME_TI(cmd_F, "ReturnList"))	ModalResult = mrCancel;
		else handled = false;
	}
	catch (EAbort &e) {
		beep_Warn();
	}

	if (!is_DialogKey(Key) || handled) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	//CN^T[`
	if (_istalnum(Key) || is_KeyDown(VK_CONTROL)) Key = 0;
}
//---------------------------------------------------------------------------
//}EX
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::DirHistListBoxDblClick(TObject *Sender)
{
	perform_Key_RETURN((TControl*)Sender);
}

//---------------------------------------------------------------------------
//wfBNgȉS̗ɒǉ
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::AddDirsActionExecute(TObject *Sender)
{
	UnicodeString dnam = CurPathName;
	if (UserModule->SelectDirEx(_T("S̗ɒǉfBNgI"), dnam)) {
		cursor_HourGlass();
		std::unique_ptr<TStringList> sbuf(new TStringList());
		sbuf->Add(IncludeTrailingPathDelimiter(dnam));
		get_dirs(dnam, sbuf.get());
		int cnt = 0;
		for (int i=0; i<sbuf->Count; i++) {
			UnicodeString pnam = IncludeTrailingPathDelimiter(sbuf->Strings[i]);
			if (indexof_csv_list(AllDirHistory, pnam, 0)==-1) {
				AllDirHistory->Add(UnicodeString().sprintf(_T("\"%s\",0"), pnam.c_str()));
				cnt++;
			}
		}
		AllDirHistory->Sort();
		UpdateListBox();
		cursor_Default();
		msgbox_OK(UnicodeString().sprintf(_T("%u̃fBNgǉ܂B"), cnt));
	}
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::AddDirsActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction*)Sender;
	ap->Visible = IsFindDirHist;
	ap->Enabled = ExtSaveDirHist;
}

//---------------------------------------------------------------------------
//ׂč폜
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::ClearAllActionExecute(TObject *Sender)
{
	if (IsAllDirHist || IsFindDirHist) {
		if (msgbox_Sure(LoadUsrMsg(USTR_DelHistoryQ, _T("S"))))
			AllDirHistory->Clear();
	}
	else if (!IsDirStack) {
		if (msgbox_Sure(LoadUsrMsg(USTR_DelHistoryQ, get_LRUD_str().UCAT_T(""))))
			clear_DirHistory(CurTabIndex, CurListTag);
	}
	UpdateListBox();
}
//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::ClearAllActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction*)Sender;
	ap->Enabled = !IsDirStack;
	ap->Caption = (IsAllDirHist || IsFindDirHist)? "Sׂ̗č폜(&A)" : "Jgׂ̗č폜(&A)";
}

//---------------------------------------------------------------------------
void __fastcall TDirHistoryDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift);
}
//---------------------------------------------------------------------------

